#ifndef EMAP_H
#define EMAP_H

#include <stdlib.h>
#include <stdio.h>
#include <setjmp.h>

#include "resizeable_buf.h"

enum action_type { ACTION_EXEC, ACTION_INJECT, ACTION_EXIT, ACTION_DIE };

struct key {
        char *name;
        unsigned int keysym;
        unsigned int state;
};

struct map {
        struct key leader;
        char *string;
        enum action_type atype;
        char *adata;
};

/* structures for communicating with the parser */
struct tok_data {
        unsigned len;
        char *data;
};

struct parse_data {
        struct map map;
        int errorcount;
        char *filename;
        int line;
        jmp_buf error_jmp;
        rb_t rb;
        int rb_start;
};

char *stringize_token(struct tok_data);

void dump_maps(FILE *file, struct map *map, int count); 




#endif
