/* Generated by re2c 0.5 on Fri Sep 19 19:54:05 2003 */
#line 1 "./scanner.re2c"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/fcntl.h>

#include "scanner.h"
#include "parser.h"
#include "resizeable_buf.h"

typedef struct Scanner {
	int	fd;
	char *bot, *tok, *ptr, *cur, *pos, *lim, *top, *eof;
} Scanner;

#define	BSIZE	8192

#define	YYCTYPE		char
#define	YYCURSOR	(cursor)
#define	YYLIMIT		(s->lim)
#define	YYMARKER	(s->ptr)
#define	YYFILL(n)	{cursor = fill(s, cursor);}


static char *fill(Scanner *s, char *cursor){
    if(!s->eof){
	unsigned int cnt = s->tok - s->bot;
	if(cnt){
	    memcpy(s->bot, s->tok, s->lim - s->tok);
	    s->tok = s->bot;
	    s->ptr -= cnt;
	    cursor -= cnt;
	    s->pos -= cnt;
	    s->lim -= cnt;
	}
	if((s->top - s->lim) < BSIZE){
	    char *buf = malloc(((s->lim - s->bot) + BSIZE)*sizeof(char));
	    memcpy(buf, s->tok, s->lim - s->tok);
	    s->tok = buf;
	    s->ptr = &buf[s->ptr - s->bot];
	    cursor = &buf[cursor - s->bot];
	    s->pos = &buf[s->pos - s->bot];
	    s->lim = &buf[s->lim - s->bot];
	    s->top = &s->lim[BSIZE];
	    free(s->bot);
	    s->bot = buf;
	}
	if((cnt = read(s->fd, (char*) s->lim, BSIZE)) != BSIZE){
	    s->eof = &s->lim[cnt]; *(s->eof)++ = '\n';
	}
	s->lim += cnt;
    }
    return cursor;
}

void ParseTrace(FILE *TraceFILE, char *zTracePrompt);
void *ParseAlloc(void *(*mallocProc)(int));
void ParseFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
);
void Parse(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  struct tok_data yyminor,       /* The value for the token */
  struct parse_data *pd
);

void scan_emap(int fd, struct parse_data *pd) {
        void *pParser = ParseAlloc( (void*)malloc );
        Scanner in;
        struct tok_data td;
        Scanner *s = &in;
	char *cursor;
        memset((void *)&in, 0, sizeof(in));
        assert(fd != -1);
        in.fd = fd;
        cursor = s->cur;
std:
	s->tok = cursor;
#line 97


{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy0;
yy1:	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 7) YYFILL(7);
	yych = *YYCURSOR;
	switch(yych){
	case '\t':	case '\v':
	case '\f':
	case '\r':	case ' ':	goto yy19;
	case '\n':	goto yy21;
	case '"':	goto yy17;
	case '#':	goto yy4;
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':	case 'f':
	case 'g':
	case 'h':	case 'j':	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy18;
	case '/':	goto yy2;
	case '<':	goto yy12;
	case 'd':	goto yy11;
	case 'e':	goto yy10;
	case 'i':	goto yy9;
	case 'k':	goto yy6;
	case 's':	goto yy8;
	case '{':	goto yy13;
	case '}':	goto yy15;
	default:	goto yy23;
	}
yy2:	yych = *++YYCURSOR;
	switch(yych){
	case '*':	goto yy66;
	default:	goto yy3;
	}
yy3:
#line 133
	{
		fprintf(stderr,"%s:%i:unexpected character %c\n",pd->filename, pd->line+1,*s->tok);
		pd->errorcount++;
		goto std;
	    }
yy4:	yych = *++YYCURSOR;
yy5:
#line 101
	{ goto linecomment; }
yy6:	yych = *++YYCURSOR;
	switch(yych){
	case 'e':	goto yy63;
	default:	goto yy27;
	}
yy7:
#line 113
	{
                int len = cursor - s->tok;
		fprintf(stderr,"%s:%i:unexpected word '",pd->filename, pd->line+1);
                fwrite(s->tok, len, 1, stderr);
                fprintf(stderr, "'\n");
		pd->errorcount++;
		goto std;
             }
yy8:	yych = *++YYCURSOR;
	switch(yych){
	case 't':	goto yy57;
	default:	goto yy27;
	}
yy9:	yych = *++YYCURSOR;
	switch(yych){
	case 'n':	goto yy51;
	default:	goto yy27;
	}
yy10:	yych = *++YYCURSOR;
	switch(yych){
	case 'x':	goto yy40;
	default:	goto yy27;
	}
yy11:	yych = *++YYCURSOR;
	switch(yych){
	case 'i':	goto yy37;
	default:	goto yy27;
	}
yy12:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch(yych){
	case '*':	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy32;
	case '>':	goto yy35;
	default:	goto yy3;
	}
yy13:	yych = *++YYCURSOR;
yy14:
#line 109
	{ Parse(pParser, LBRACE, td, pd); goto std; }
yy15:	yych = *++YYCURSOR;
yy16:
#line 110
	{ Parse(pParser, RBRACE, td, pd); goto std; }
yy17:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy29;
yy18:	yych = *++YYCURSOR;
	goto yy27;
yy19:	yych = *++YYCURSOR;
	goto yy25;
yy20:
#line 123
	{ goto std; }
yy21:	yych = *++YYCURSOR;
yy22:
#line 125
	{
		if(cursor == s->eof) 
                            goto done;
		s->pos = cursor; pd->line++;
		goto std;
	    }
yy23:	yych = *++YYCURSOR;
	goto yy3;
yy24:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy25:	switch(yych){
	case '\t':	case '\v':
	case '\f':
	case '\r':	case ' ':	goto yy24;
	default:	goto yy20;
	}
yy26:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy27:	switch(yych){
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy26;
	default:	goto yy7;
	}
yy28:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy29:	switch(yych){
	case '"':	goto yy30;
	default:	goto yy28;
	}
yy30:	yych = *++YYCURSOR;
yy31:
#line 111
	{ td.data = s->tok + 1; td.len = cursor - s->tok - 2; Parse(pParser, STRINGVAL, td, pd); goto std; }
yy32:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy33:	switch(yych){
	case '*':	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy32;
	case '>':	goto yy35;
	default:	goto yy34;
	}
yy34:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 1:	goto yy7;
	case 0:	goto yy3;
	}
yy35:	yych = *++YYCURSOR;
yy36:
#line 108
	{ td.data = s->tok + 1; td.len = cursor - s->tok - 2; Parse(pParser, KEYVAL, td, pd); goto std; }
yy37:	yych = *++YYCURSOR;
	switch(yych){
	case 'e':	goto yy38;
	default:	goto yy27;
	}
yy38:	yych = *++YYCURSOR;
	switch(yych){
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy26;
	default:	goto yy39;
	}
yy39:
#line 106
	{ Parse(pParser, DIE, td, pd); goto std; }
yy40:	yych = *++YYCURSOR;
	switch(yych){
	case 'e':	goto yy42;
	case 'i':	goto yy41;
	default:	goto yy27;
	}
yy41:	yych = *++YYCURSOR;
	switch(yych){
	case 't':	goto yy49;
	default:	goto yy27;
	}
yy42:	yych = *++YYCURSOR;
	switch(yych){
	case 'c':	goto yy43;
	default:	goto yy27;
	}
yy43:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy44:	switch(yych){
	case '\n':	goto yy47;
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy43;
	default:	goto yy45;
	}
yy45:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy46:	switch(yych){
	case '\n':	goto yy47;
	default:	goto yy45;
	}
yy47:	yych = *++YYCURSOR;
yy48:
#line 107
	{ td.data = s->tok + 4; td.len = cursor - s->tok - 5; Parse(pParser, EXEC, td, pd); goto std; }
yy49:	yych = *++YYCURSOR;
	switch(yych){
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy26;
	default:	goto yy50;
	}
yy50:
#line 105
	{ Parse(pParser, EXIT, td, pd); goto std; }
yy51:	yych = *++YYCURSOR;
	switch(yych){
	case 'j':	goto yy52;
	default:	goto yy27;
	}
yy52:	yych = *++YYCURSOR;
	switch(yych){
	case 'e':	goto yy53;
	default:	goto yy27;
	}
yy53:	yych = *++YYCURSOR;
	switch(yych){
	case 'c':	goto yy54;
	default:	goto yy27;
	}
yy54:	yych = *++YYCURSOR;
	switch(yych){
	case 't':	goto yy55;
	default:	goto yy27;
	}
yy55:	yych = *++YYCURSOR;
	switch(yych){
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy26;
	default:	goto yy56;
	}
yy56:
#line 104
	{ Parse(pParser, INJECT, td, pd); goto std; }
yy57:	yych = *++YYCURSOR;
	switch(yych){
	case 'r':	goto yy58;
	default:	goto yy27;
	}
yy58:	yych = *++YYCURSOR;
	switch(yych){
	case 'i':	goto yy59;
	default:	goto yy27;
	}
yy59:	yych = *++YYCURSOR;
	switch(yych){
	case 'n':	goto yy60;
	default:	goto yy27;
	}
yy60:	yych = *++YYCURSOR;
	switch(yych){
	case 'g':	goto yy61;
	default:	goto yy27;
	}
yy61:	yych = *++YYCURSOR;
	switch(yych){
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy26;
	default:	goto yy62;
	}
yy62:
#line 103
	{ Parse(pParser, STRING, td, pd); goto std; }
yy63:	yych = *++YYCURSOR;
	switch(yych){
	case 'y':	goto yy64;
	default:	goto yy27;
	}
yy64:	yych = *++YYCURSOR;
	switch(yych){
	case '-':	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':	case '_':	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy26;
	default:	goto yy65;
	}
yy65:
#line 102
	{ Parse(pParser, KEY, td, pd); goto std; }
yy66:	yych = *++YYCURSOR;
yy67:
#line 100
	{ goto comment; }
}
#line 138


comment:
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy68;
yy69:	++YYCURSOR;
yy68:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch(yych){
	case '\n':	goto yy72;
	case '*':	goto yy70;
	default:	goto yy74;
	}
yy70:	yych = *++YYCURSOR;
	switch(yych){
	case '/':	goto yy75;
	default:	goto yy71;
	}
yy71:
#line 149
	{ goto comment; }
yy72:	yych = *++YYCURSOR;
yy73:
#line 143
	{
		if(cursor == s->eof) 
                    goto done;
		s->tok = s->pos = cursor; pd->line++;
		goto comment;
	    }
yy74:	yych = *++YYCURSOR;
	goto yy71;
yy75:	yych = *++YYCURSOR;
yy76:
#line 142
	{ goto std;}
}
#line 150
 
linecomment:
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy77;
yy78:	++YYCURSOR;
yy77:
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch(yych){
	case '\n':	goto yy79;
	default:	goto yy81;
	}
yy79:	yych = *++YYCURSOR;
yy80:
#line 153
	{
			if(cursor == s->eof) 
                            goto done;
			s->tok = s->pos = cursor; pd->line++;
			goto std;
		}
yy81:	yych = *++YYCURSOR;
yy82:
#line 159
	{goto linecomment;}
}
#line 160


done:
        Parse(pParser, 0, td, pd);
        ParseFree(pParser, free);
        if (pd->errorcount > 0 ) {
                fprintf(stderr, "There were %i errors.\n", pd->errorcount);
                exit(2);
        }

}



